initial_clus <- function ( kernel_exp, cut_off ){
#INPUT:
  #kernel_exp: expressions of kernel genes/probes over the specified conditions, a 
  #numeric matrix s.t. each row corresponds to the expression vector of a kernel gene

  r = cor(t(kernel_exp))
  
  ng = nrow(kernel_exp)
  gene_pool = c(1:ng)
  init_clus <-list()
#  k = 1
  while (length(gene_pool)!=0){
      gene = gene_pool[1]
      clus = c(gene);
      for (i in 1:length(gene_pool)){
          if (gene != gene_pool[i] && r[gene,gene_pool[i]]>= cut_off){
              clus = c(clus, gene_pool[i])
          } 
      }
      gene_pool = setdiff(gene_pool,clus)
      init_clus[length(init_clus)+1] <- list(clus)
#      k = k+1
  }
  return(init_clus)
}