kcs<- function (de_exp, centres, kernel_exp ){

#This function calculates kernel concordance scores for each fo the differentially expressed genes
#INPUTS:
  #de_exp: expressions of differentially expressed genes/probes over the specified conditions, a numeric matrix s.t. each row corresponds to the expression vector of a differntially expressed gene
  #kernel_exp: expressions of kernel genes/probes over the specified conditions, a numeric matrix s.t. each row corresponds to the expression vector of a kernel gene
  #centres: a numeric array of kernel gene ids s.t. its i_th element gives the id of the centre of i_th cluster
 

  data = de_exp
  n = nrow(data)
  de_score = rep(0,n)
  k = length(centres)
  for (i in 1:n){
    d = rep(0,k)
    for (j in 1:k){
      c = kernel_exp[centres[j],]
      d[j] = cor(data[i,],c)
    }
  de_score[i] = max(d)
  }
  
  return(de_score)
}
